<?php
/**
*
* @package acp_xbl
* @version $Id: acp_xbl.php, v 0.7 2007/10/18 CoC
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @package acp_xbl
*/
class acp_xbl
{
	var $u_action;
	var $new_config = array();

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;


		$action	= request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		switch ($mode)
		{

			case 'xbl':
				$display_vars = array(
					'title'			=> 'ACP_XBL_SETTINGS',
					'vars'			=> array(
						'legend1'						=> 'GENERAL_OPTIONS',
						'allow_xbl'					=> array('lang' => 'ALLOW_XBL',					'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
						'allow_xbl_posts'		=> array('lang' => 'ALLOW_XBL_POSTS',		'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
						'acp_xbl'						=> array('lang' => 'ADMIN_XBL_STYLE',		'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
						'allow_xbl_small'		=> array('lang' => 'ALLOW_SMALL_TAG',		'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
						'allow_xbl_voice'		=> array('lang' => 'ALLOW_VOICE_ACP',		'validate' => 'bool',	'type' => 'radio:yes_no', 'explain' => true),
					)
				);
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];


				$data = array(
					'bg_tag'			=> request_var('bg_tag', $config['xbl_bg_tag']),
					'bg_style'		=> request_var('bg_style', $config['xbl_bg_colour']),
					'vp_tag'			=> request_var('vp_tag', $config['xbl_pf_tag']),
					'vp_style'		=> request_var('vp_style', $config['xbl_pf_colour']),
				);

			if ($submit)
			{
				set_config($config_name, $config_value);
				set_config('xbl_bg_tag', $data['bg_tag']);
				set_config('xbl_bg_colour', $data['bg_style']);
				set_config('xbl_pf_tag', $data['vp_tag']);
				set_config('xbl_pf_colour', $data['vp_style']);
			}
		}

		if ($submit)
		{
			add_log('admin', 'LOG_CONFIG_' . strtoupper($mode));

			trigger_error($user->lang['USER_XBL_UPDATED'] . adm_back_link($this->u_action));
		}

		$this->tpl_name = 'acp_xbl';
		$this->page_title = $display_vars['title'];

		$template->assign_vars(array(
			'L_TITLE'						=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'S_ERROR'						=> (sizeof($error)) ? true : false,
			'ERROR_MSG'					=> implode('<br />', $error),
			'U_BG_TAG'					=> $config['xbl_bg_tag'],
			'U_BG_STYLE'				=> $config['xbl_bg_colour'],
			'U_VP_TAG'					=>$config['xbl_pf_tag'],
			'U_VP_STYLE'				=> $config['xbl_pf_colour'],
			'TAG_ID'						=> $user->lang['LIVE_ID'],
			'U_ACTION'					=> $this->u_action)
		);

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'			=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$template->assign_block_vars('options', array(
				'KEY'						=> $config_key,
				'TITLE'					=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'			=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'CONTENT'				=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>