<?php
/*-----------------------------------------------------------------------------
    Modification Installer for phpBB 3
  ----------------------------------------------------------------------------
    install.php
       SQL Installer Script
    Generation Date: June 03, 2008  
  ----------------------------------------------------------------------------
	This file is released under the GNU General Public License Version 2.
-----------------------------------------------------------------------------*/

define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include_once($phpbb_root_path . 'common.'.$phpEx);

// Session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('acp/common');

if ($user->data['user_id'] == ANONYMOUS)
{
	login_box("install_xbox_mod.$phpEx", $user->lang['LOGIN_ADMIN'], $user->lang['LOGIN_ADMIN_SUCCESS']);
}

if (!$auth->acl_get('a_'))
{
	trigger_error($user->lang['NO_ADMIN']);
}

$mod = array(
	'name'			=>	'Xbox Live Tag Mod',
	'version'		=>	'1.1.0',
	'copy_year'		=>	'2008',
	'author'		=>	'CoC',
	'website'		=>	'http://www.phpbb.com/community/viewtopic.php?f=70&t=573094',
	'sitename'		=>	'phpbb.com',
	'prev_version'	=>	'1.0.0',
);

$install = $uninstall = $upgrade = FALSE;
$sql = $module_data = array();
switch( $dbms )
{
	case 'postgres':
		$sql["install"] = array(
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_xbl BYTEA",
	"UPDATE TABLE " . $table_prefix . "users SET user_xbl = '' WHERE user_xbl IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl SET NOT NULL",
	"INSERT INTO " . $table_prefix . "config VALUES('acp_xbl','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_small','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_posts','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_pf_tag','gel','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_bg_tag','gelsig','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_bg_colour','blue','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_pf_colour','blue','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_voice','0','0')",
	"ALTER TABLE " . $table_prefix . "posts ADD COLUMN enable_xbl SMALLINT",
	"ALTER TABLE " . $table_prefix . "posts ALTER COLUMN enable_xbl SET DEFAULT 1",
	"UPDATE TABLE " . $table_prefix . "posts SET enable_xbl = 1 WHERE enable_xbl IS NULL",
	"ALTER TABLE " . $table_prefix . "posts ALTER COLUMN enable_xbl SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_allow_xbl SMALLINT",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_allow_xbl SET DEFAULT 1",
	"UPDATE TABLE " . $table_prefix . "users SET user_allow_xbl = 1 WHERE user_allow_xbl IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_allow_xbl SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_show_xbl SMALLINT",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_show_xbl SET DEFAULT 1",
	"UPDATE TABLE " . $table_prefix . "users SET user_show_xbl = 1 WHERE user_show_xbl IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_show_xbl SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN allow_xbl_small SMALLINT",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN allow_xbl_small SET DEFAULT 1",
	"UPDATE TABLE " . $table_prefix . "users SET allow_xbl_small = 1 WHERE allow_xbl_small IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN allow_xbl_small SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN xbl_voice_tag SMALLINT",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN xbl_voice_tag SET DEFAULT 0",
	"UPDATE TABLE " . $table_prefix . "users SET xbl_voice_tag = 0 WHERE xbl_voice_tag IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN xbl_voice_tag SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_xbl_vt_colour VARCHAR(12)",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vt_colour SET DEFAULT 'blue'",
	"UPDATE TABLE " . $table_prefix . "users SET user_xbl_vt_colour = 'blue' WHERE user_xbl_vt_colour IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vt_colour SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_xbl_vp_colour VARCHAR(12)",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vp_colour SET DEFAULT 'blue'",
	"UPDATE TABLE " . $table_prefix . "users SET user_xbl_vp_colour = 'blue' WHERE user_xbl_vp_colour IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vp_colour SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_xbl_vp_tag VARCHAR(12)",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vp_tag SET DEFAULT 'gel'",
	"UPDATE TABLE " . $table_prefix . "users SET user_xbl_vp_tag = 'gel' WHERE user_xbl_vp_tag IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vp_tag SET NOT NULL",
	"ALTER TABLE " . $table_prefix . "users ADD COLUMN user_xbl_vt_tag VARCHAR(12)",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vt_tag SET DEFAULT 'gelsig'",
	"UPDATE TABLE " . $table_prefix . "users SET user_xbl_vt_tag = 'gelsig' WHERE user_xbl_vt_tag IS NULL",
	"ALTER TABLE " . $table_prefix . "users ALTER COLUMN user_xbl_vt_tag SET NOT NULL");
		$sql["uninstall"] = array(
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_xbl CASCADE",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'acp_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_small'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_posts'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_voice'",
	"ALTER TABLE " . $table_prefix . "posts DROP COLUMN enable_xbl CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_allow_xbl CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_show_xbl CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN allow_xbl_small CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN xbl_voice_tag CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_xbl_vt_colour CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_xbl_vp_colour CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_xbl_vp_tag CASCADE",
	"ALTER TABLE " . $table_prefix . "users DROP COLUMN user_xbl_vt_tag CASCADE");
		
	break;

	case 'mssql':
		$sql["install"] = array(
	"INSERT INTO " . $table_prefix . "config VALUES('acp_xbl','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_small','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_posts','1','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_pf_tag','gel','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_bg_tag','gelsig','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_bg_colour','blue','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('xbl_pf_colour','blue','0')",
	"INSERT INTO " . $table_prefix . "config VALUES('allow_xbl_voice','0','0')");
		$sql["uninstall"] = array(
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'acp_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_small'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_posts'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_voice'");
		
	break;

	case 'mysql':
	case 'mysql4':
	default:
		$sql["install"] = array(
	"ALTER TABLE " . $table_prefix . "users ADD user_xbl blob NOT NULL",
	"INSERT INTO " . $table_prefix . "config VALUES ('acp_xbl', '1', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('allow_xbl_small', '1', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('allow_xbl', '1', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('allow_xbl_posts', '1', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('xbl_pf_tag', 'gel', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('xbl_bg_tag', 'gelsig', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('xbl_bg_colour', 'blue', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('xbl_pf_colour', 'blue', '0')",
	"INSERT INTO " . $table_prefix . "config VALUES ('allow_xbl_voice', '0', '0')",
	"ALTER TABLE " . $table_prefix . "posts ADD enable_xbl TINYINT( 1 ) NOT NULL DEFAULT '1'",
	"ALTER TABLE " . $table_prefix . "users ADD user_allow_xbl TINYINT( 1 ) NOT NULL DEFAULT '1'",
	"ALTER TABLE " . $table_prefix . "users ADD user_show_xbl TINYINT( 1 ) NOT NULL DEFAULT '1'",
	"ALTER TABLE " . $table_prefix . "users ADD allow_xbl_small TINYINT( 1 ) NOT NULL DEFAULT '1'",
	"ALTER TABLE " . $table_prefix . "users ADD xbl_voice_tag TINYINT( 1 ) NOT NULL DEFAULT '0'",
	"ALTER TABLE " . $table_prefix . "users ADD user_xbl_vt_colour VARCHAR( 12 ) NOT NULL DEFAULT 'blue'",
	"ALTER TABLE " . $table_prefix . "users ADD user_xbl_vp_colour VARCHAR( 12 ) NOT NULL DEFAULT 'blue'",
	"ALTER TABLE " . $table_prefix . "users ADD user_xbl_vp_tag VARCHAR( 12 ) NOT NULL DEFAULT 'gel'",
	"ALTER TABLE " . $table_prefix . "users ADD user_xbl_vt_tag VARCHAR( 12 ) NOT NULL DEFAULT 'gelsig'");
		$sql["uninstall"] = array(
	"ALTER TABLE " . $table_prefix . "users DROP user_xbl",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'acp_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_small'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_posts'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_tag'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_bg_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'xbl_pf_colour'",
	"DELETE FROM " . $table_prefix . "config WHERE config_name = 'allow_xbl_voice'",
	"ALTER TABLE " . $table_prefix . "posts DROP enable_xbl",
	"ALTER TABLE " . $table_prefix . "users DROP user_allow_xbl",
	"ALTER TABLE " . $table_prefix . "users DROP user_show_xbl",
	"ALTER TABLE " . $table_prefix . "users DROP allow_xbl_small",
	"ALTER TABLE " . $table_prefix . "users DROP xbl_voice_tag",
	"ALTER TABLE " . $table_prefix . "users DROP user_xbl_vt_colour",
	"ALTER TABLE " . $table_prefix . "users DROP user_xbl_vp_colour",
	"ALTER TABLE " . $table_prefix . "users DROP user_xbl_vp_tag",
	"ALTER TABLE " . $table_prefix . "users DROP user_xbl_vt_tag");
		
	break;
}

$module_data['install'] = array(
	array('basename' => 'xbl', 'class' => 'acp'),
	array('basename' => 'prefs', 'class' => 'ucp'),
	array('basename' => 'users', 'class' => 'acp'),
);




if( !empty($sql['install']) || !empty($module_data['install']) )
{
	$install = TRUE;
}

if( !empty($sql['uninstall']) || !empty($module_data['uninstall']) )
{
	$uninstall = TRUE;
}

if( !empty($sql['upgrade']) || !empty($module_data['upgrade']) )
{
	$upgrade = TRUE;
}

require_once($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);
$acp_modules	= new acp_modules();

$page_title = $mod['name'] . ' Installer';
$action = request_var('action', '');

$version_string = $of_name = $for_name = '';
if( !empty($mod['name']) )
{
	$of_name  = ' of ' . $mod['name'];
	$for_name = ' for ' . $mod['name'];
}

if( !empty($mod['prev_version']) && !empty($mod['version']) )
{
	$version_string = " from {$mod['name']} {$mod['prev_version']} to {$mod['name']} {$mod['version']}";
}

$page_head = <<<EOH
<html>
<head>
<title>$page_title</title>
<style type="text/css">
<!--
body
{
	color: black;
	background-color: blanchedalmond;
	margin: 0;
	padding: 0;
	font-size: 15px;
	font-family: Verdana, Tahoma, Arial, Helvetica, sans-serif;
}

a
{
	background-color: inherit;
	text-decoration: none;
	font-size: 1.0em;
}

a:hover
{
	color: green;
	background-color: inherit;
	text-decoration: underline;
}

div#header
{
	width: 100%;
	color: saddlebrown;
	background-position: right bottom;
	border: none;
	margin-top: 0.4em;
	margin-bottom: 0.5em;
}

#logo
{
	font-size: 1.8em;
	font-weight: bold;
	padding-left: 0.5em;
}

#logo a, #logo a:hover
{
	color: saddlebrown;
	font-size: 1em;
}

#footer
{
	clear: both;
	border: none;
	border-top: 1px solid saddlebrown;
	margin: 0;
	padding: 0.3em;
	font-size: 0.7em;
	text-align: right;
}

#content
{
	background: ivory;
	border-top: 1px solid saddlebrown;
	margin-top: 0;
	padding: 0.5em 1em 0.1em;
	text-align: justify;
}

p, ul
{
	font-size: 0.8em;
}

.error
{
	font-weight: bold;
	color: red;
}

.success
{
	font-weight: bold;
	color: green;
}
-->
</style>
</head>
<body>
<div id="header">
	<div id="logo">$page_title</div>
</div>
<div id="content">
<p>
	Welcome to the {$page_title}. This is a script that you can use to install, uninstall, or upgrade the database changes required for the {$mod['name']} modification to operate correctly on your phpBB 3 forum. Please select an option below to continue.
</p>
<p>
	Please remember that this script only works with the database changes required $for_name on phpBB 3. Any file alterations or additions must be installed, uninstalled, or upgraded separately. Check the documentation $of_name for details on such steps.
</p>
EOH;

$page_tail = <<<EOH
	</div>
	<div id="footer">
		{$mod['name']} Copyright &copy; {$mod['copy_year']} by <a href="{$mod['website']}" title="Visit this web site for support">{$mod['author']}</a>
	</div>
</body>
</html>
EOH;

$url_append = $phpEx . '?sid=' . $user->data['session_id'];
$page_postaction = <<<EOH
	</p>

	<p>You should now delete install.php from your forum.</p>
	
	<p class="alert">Be sure to visit the <a href="adm/index.$url_append">Administration Control Panel</a> to check and update any configuration options that may have been affected by this process.</p>
EOH;

$results = array();
$db_errors = FALSE;
$db->sql_return_on_error(true);
$page_text = '';
if( empty($action) || !in_array($action, array('install', 'upgrade', 'uninstall')) )
{
	$page_text = <<<EOH
	<p class="alert">Please note that before proceeding, you should have or create a current full backup of your database. A backup can be used to restore your forum to a state prior to the results of any actions taken by this installer, if necessary.</p>
	<p>
EOH;
	if( $install )
	{
		$page_text .= <<<EOH
	<ul>
		<li><a href="install_xbox_mod.$url_append&amp;action=install">Install Database Changes</a></li>
EOH;
	}
	if( $uninstall )
	{
		$page_text .= <<<EOH
		<li><a href="install_xbox_mod.$url_append&amp;action=uninstall">Uninstall Database Changes</a></li>
EOH;
	}
	if( $upgrade )
	{
		$page_text .= <<<EOH
		<li><a href="install_xbox_mod.$url_append&amp;action=upgrade">Upgrade Database Changes $version_string</a></li>
EOH;
	}
	$page_text .= <<<EOH
	</ul>
	</p>
EOH;
}
else
{
	run_installer();
}

function run_installer()
{
	global $action, $page_text, $for_name, $results, $install, $uninstall, $upgrade;

	if( !$$action )
	{
		$page_text .= '<p>';
		switch( $action )
		{
			case 'install':
				$page_text .= 'Installation';
			break;
			case 'uninstall':
				$page_text .= 'Uninstallation';
			break;
			case 'upgrade':
				$page_text .= 'Upgrading';
			break;
		}
		$page_text .= ' is not supported for ' . $for_name . '.</p>';
	}
	else
	{
		$page_text = "
			<p>This installer will now attempt to make the database changes{$for_name}.</p>";
		process_sql();
		process_modules();

		if( empty($results) )
		{
			$results[] = '<li>No changes were attempted! You may have already run the installer successfully.</li>';
		}
		$page_text .= '<ul>' . implode("\n", $results) . '</ul>
		<p>
			The installer process is now complete.';
	}
}

function process_modules()
{
	global $action, $module_data;
	if( empty($module_data[$action]) )
	{
		return;
	}
	switch( $action )
	{
		case 'install':
			add_modules($module_data['install']);
		break;
		case 'upgrade':
			remove_modules($module_data['upgrade']['remove']);
			add_modules($module_data['upgrade']['add']);
		break;
		case 'uninstall':
			remove_modules($module_data['uninstall']);
		break;
	}
}

function get_cat_ids($details, $module_class)
{
	global $db;

	$parents = array();
	if( !isset($details['cat']) )
	{
		return array(0);
	}
	$cats = $details['cat'];
	$sql = 'SELECT module_id FROM ' . MODULES_TABLE . '
			WHERE ' . $db->sql_in_set('module_langname', $cats) . "
				AND module_class = '" . $db->sql_escape($module_class) . "'";
	$result = $db->sql_query($sql);
	while( $row = $db->sql_fetchrow($result) )
	{
		$parents[] = $row['module_id'];
	}
	$db->sql_freeresult($result);

	if( empty($parents) )
	{
		$parents = array(0);
	}

	return $parents;
}

function remove_modules($modules)
{
	global $db, $phpbb_root_path, $phpEx, $acp_modules;

	if( empty($modules) )
	{
		return;
	}
	foreach($modules as $k=>$v)
	{
		// Check if module name and mode exist...
		$module_basename	= $v['basename'];
		$module_class		= $v['class'];
		if( !check_for_info($module_class, $module_basename) )
		{
			continue;
		}
		$fileinfo = $acp_modules->get_module_infos($module_basename, $module_class);
		$fileinfo = $fileinfo[$module_basename];

		if( !empty($fileinfo['modes']) )
		{
			uninstall_modules($fileinfo['modes'], $module_class, $module_basename);
		}

		if( isset($fileinfo['new_parents']) )
		{
			uninstall_modules($fileinfo['new_parents'], $module_class, '', true);
		}
	}
}

function uninstall_modules($modules, $module_class, $module_basename, $cats_only = FALSE)
{
	global $acp_modules, $db, $user;
	$modules = array_reverse($modules);
	foreach($modules as $module_mode => $mode_details)
	{
		// We need to get the module_id for each mode.
		$sql = 'SELECT module_id FROM ' . MODULES_TABLE . "
				WHERE module_langname = '" . $db->sql_escape($mode_details['title']) . "'
					AND module_class = '" . $db->sql_escape($module_class) . "'";
		$result = $db->sql_query($sql);
		$rows = $db->sql_fetchrowset($result);
		$db->sql_freeresult($result);
		$acp_modules->module_class = $module_class;

		$msg = "Removal of module $module_basename, mode $module_mode";
		if( $cats_only )
		{
			$cat_name = ( isset($user->lang[$mode_details['title']]) ) ? $user->lang[$mode_details['title']] : $mode_details['title'];
			$msg = "Removal of menu category $cat_name";
		}

		if( empty($rows) )
		{
			add_result($msg, "This could not be removed because it was not already installed.");
			continue;
		}
		foreach($rows as $v)
		{
			$result = $acp_modules->delete_module($v['module_id']);
			if( !empty($result) )
			{
				add_result($msg, $result[0]);
			}
			else
			{
				add_result($msg);
			}
		}
	}
}

function check_for_info($module_class, $module_basename)
{
	global $phpbb_root_path, $phpEx;
	$module_file = $phpbb_root_path . 'includes/' . $module_class . '/info/' . $module_class . '_' .$module_basename . '.' . $phpEx;
	if( !@file_exists($module_file) )
	{
		add_result("Module $module_basename", "The module's info file has not been uploaded. The module cannot be edited without the info file.");
		return FALSE;
	}
	return TRUE;
}

function check_for_installed($mode_details, $module_class, $parents)
{
	global $db;

	$parent_sql = '';
	if( !empty($parents) )
	{
		if( !is_array($parents) )
		{
			$parents = array($parents);
		}
		$parent_sql = ' AND ' . $db->sql_in_set('parent_id', $parents);
	}
	$sql = 'SELECT module_id FROM ' . MODULES_TABLE . "
			WHERE module_langname = '" . $db->sql_escape($mode_details['title']) . "'
				AND module_class = '" . $db->sql_escape($module_class) . "'";
	$sql .= $parent_sql;
	$result = $db->sql_query($sql);
	$rows = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);
	if( empty($rows) )
	{
		return FALSE;
	}
	
	return TRUE;
}

function add_modules($new_modules)
{
	global $db, $phpbb_root_path, $phpEx, $acp_modules;

	if( empty($new_modules) )
	{
		return;
	}
	foreach($new_modules as $k=>$v)
	{
		// Check if module name and mode exist...
		$module_class		= $v['class'];
		$module_basename	= $v['basename'];
		if( !check_for_info($module_class, $module_basename) )
		{
			continue;
		}
		$fileinfo = $acp_modules->get_module_infos($module_basename, $module_class);
		$fileinfo = $fileinfo[$module_basename];

		if( isset($fileinfo['new_parents']) )
		{
			install_modules($fileinfo['new_parents'], $module_class, '', true);
		}

		if( !empty($fileinfo['modes']) )
		{
			install_modules($fileinfo['modes'], $module_class, $module_basename);
		}
	}
}

function install_modules($modules, $module_class, $module_basename, $cats_only = FALSE)
{
	global $acp_modules, $user;
	$install_basename = $module_basename;
	foreach($modules as $module_mode => $mode_details)
	{
		$install_mode = $module_mode;
		// We need to get the parent for the mode.
		$parents = get_cat_ids($mode_details, $module_class);

		$msg = "Addition of module $module_basename, mode $module_mode";
		if( $cats_only )
		{
			$module_mode			= '';
			$mode_details['auth']	= '';
			$install_basename		= '';
			$install_mode			= '';
			$cat_name = ( isset($user->lang[$mode_details['title']]) ) ? $user->lang[$mode_details['title']] : $mode_details['title'];
			$msg = "Addition of menu category $cat_name";
		}

		foreach($parents as $parent_id)
		{
			// Check for an already installed instance of this module
			// under this parent. If it is already present, we don't install
			// again.
			if( check_for_installed($mode_details, $module_class, $parent_id) )
			{
				break;
			}
			$module_data = array(
				'module_basename'	=> $install_basename,
				'module_enabled'	=> 1,
				'module_display'	=> (isset($mode_details['display'])) ? $mode_details['display'] : 1,
				'parent_id'			=> $parent_id,
				'module_class'		=> $module_class,
				'module_langname'	=> $mode_details['title'],
				'module_mode'		=> $install_mode,
				'module_auth'		=> $mode_details['auth'],
			);

			$errors = $acp_modules->update_module_data($module_data, true);
			if( !empty($errors) )
			{
				add_result($msg, $errors[0]);
				break;
			}

			add_result($msg);
		}
	}
}

function process_sql()
{
	global $action, $sql, $db, $db_errors;
	if( empty($sql[$action]) )
	{
		return;
	}

	foreach($sql[$action] as $v)
	{
		if( !$result = $db->sql_query($v) )
		{
			$error = $db->sql_error();
			add_result($v, $error['message']);
		}
		else
		{
			add_result($v);
		}
	}
}

function wrap_up()
{
	global $cache, $action, $mod;
	add_log('admin', "<strong>Executed a modification database installer</strong><br />{$mod['name']} $action");

	// Now we will purge the cache.
	// This is necessary for any inserted or removed configuration settings
	// to take affect.
	$cache->purge();
	add_log('admin', 'LOG_PURGE_CACHE');
}

function add_result($item, $msg = '')
{
	global $results, $db_errors;
	$str = '<li>' . htmlspecialchars($item) . '<br /><span class="';
	if( !empty($msg) )
	{
		$str .= 'error">Failed due to error: ' . $msg;
		$db_errors = TRUE;
	}
	else
	{
		$str .= 'success">Completed successfully!';
	}
	$str .= '</span></li>';
	$results[] = $str;
}

function add_error_note()
{
	global $mod, $db_errors, $action;

	if( !$db_errors )
	{
		return '';
	}

	$site_string = $error_text = '';
	if( !empty($mod['website']) && !empty($mod['sitename']) )
	{
		$site_string = '<a href="' . $mod['website'] . '">' . $mod['sitename'] . '</a> or ';
	}

	$error_text .= ' If any error messages are listed above, a problem was encountered during the ';
	
	switch( $action )
	{
		case 'install':
			$error_text .= 'install. Any errors mentioning that a table already exists or duplicate entries or column names are often the result of running the install a second time by accident. Usually these errors can be ignored unless other problems appear when using the modification.';
		break;
		case 'upgrade':
			$error_text .= 'upgrade and some portions of the modification may not have been upgraded.';
		break;
		case 'uninstall':
			$error_text .= 'uninstall and some portions of the modification may not have been uninstalled.';
		break;
	}
	$error_text .= ' If you need assistance in troubleshooting these errors, please visit the support forums at ' . $site_string . ' <a href="http://www.phpbbhacks.com">phpBBHacks.com</a>.';

	return $error_text;
}

echo $page_head;
echo $page_text;
if( !empty($action) )
{
	wrap_up();
	echo add_error_note();		
	echo $page_postaction;
}
echo $page_tail;
?>